unit B42EncryptedFileStream;
interface
uses
  Classes;

type
  TB42EncryptedFileStream = class(TFileStream)
  public
    function Read(var Buffer; Count: Integer): Integer; override;
    function Write(const Buffer; Count: Integer): Integer; override;
  end;

implementation

{ TB42EncryptedFileStream }

function TB42EncryptedFileStream.Read(var Buffer; Count: Integer): Integer;
var
  i: Integer;
  Buf: String;
begin
  Result := inherited Read(Buffer, Count);
  SetLength(Buf, Count);
  Move(Buffer, PChar(@Buf[1])^, Count);
  for i:=1 to Count do Buf[i] := Chr(Ord(Buf[i]) XOR $42); // decode
  Move(PChar(@Buf[1])^, Buffer, Count);
end;

function TB42EncryptedFileStream.Write(const Buffer; Count: Integer): Integer;
var
  i: Integer;
  Buf: String;
begin
  SetLength(Buf, Count);
  Move(Buffer, PChar(@Buf[1])^, Count);
  for i:=1 to Count do Buf[i] := Chr(Ord(Buf[i]) XOR $42); // encode
  Result := inherited Write(PChar(@Buf[1])^, Count)
end;

end.
 